/*******************************************************************************

    SIRENE MULTISONS


    C/ BLUE PILL (STM32F103C8T6)


    AUTOR: CLAUDIO LARIOS

    DATA:10/05/2021

    P/ MikroC PRO for ARM V.6.2.0 (VERSO GRATUITA E LIMITADA)

    Uso didtico.
    
    Frequncia: 8 Mhz (xtal externo)
    
    ESTE ARQUIVO  PARTE INTEGRANTE DO BLOG PICSOURCE

*******************************************************************************/

#define VALOR_DESLIGAMENTO 60 * (15) //entre parenteses os minutos
#define piezo   GPIOA_ODR.B10
#define j3  GPIOB_IDR.B12
#define j4  GPIOB_IDR.B11
#define j5  GPIOB_IDR.B13
#define j6  GPIOB_IDR.B14
#define j7  GPIOB_IDR.B15

char cnt, auxa, auxb, auxc, auxd, auxe,vez=0;
char timerOut=0;


/*******************************************************************************
                   ROTINA  DE INTERRUPO DO TIMER 2
*******************************************************************************/

 void tmr2_isr() iv IVT_INT_TIM2 ics ICS_AUTO {
  TIM2_SR.UIF = 0;  //flag da interrupo (sempre precisa zera flag)
  timerOut++;
}
/*******************************************************************************
                          SUBROTINAS
*******************************************************************************/
void inverte_saida(){
char aux;
  for(aux=0;aux<cnt;aux++){ delay_us(6);}
  piezo= !piezo;
}


void som_campainha_telefone(){

    for(auxd=0; auxd<3;auxd++){//numero de execues
      cnt=100;//frequencia

      for(auxc=0; auxc<20;auxc++){//passo

       for(auxb=0; auxb<50;auxb++){//permanncia
         inverte_saida();
       }
       cnt = cnt^ 0b00001111;  //0b11010110;
     }
     delay_ms(2000);
    }
 }

void som_sirene1(){
 //   for(auxd=0; auxd<10;auxd++){//numero de execues
    cnt=40;//frequencia
     for(auxc=0; auxc<50;auxc++){//passo

       for(auxb=0; auxb<15;auxb++){//permanncia
         inverte_saida();
       }
       if(cnt>128){
         cnt = 0;
       }
       else{
         cnt = cnt + 1;
       }
     }
   // }
 }

 void som_sirene2(){//estilo = rpida
 char auxj=0;
  //  for(auxd=0; auxd<100;auxd++){//numero de execues
    cnt=40;//frequencia
     for(auxc=0; auxc<50;auxc++){//passo

       for(auxb=0; auxb<3;auxb++){//permanncia
         inverte_saida();
       }
       if(cnt>64)auxj=1;
       if(cnt==1)auxj=0;
       if(auxj==1){
         cnt = cnt - 1;
       }
       else{
         cnt = cnt + 1;
       }
     }
   // }
 }

 void som_sirene3(){
    //sirene legal (alerta)
 //   for(auxd=0; auxd<50;auxd++){//numero de execues
    cnt=100;//frequencia
     for(auxc=0; auxc<10;auxc++){//passo

       for(auxb=0; auxb<40;auxb++){//permanncia
         inverte_saida();
       }
       cnt = cnt - 2;
     }
  //  }
 }

 void som_sirene4(){
    //sirene alarme rpido 1 (toooouu! tooooouuu! toooouuu!)
  //  for(auxd=0; auxd<30;auxd++){//numero de execues
    cnt=20;//frequencia
     for(auxc=0; auxc<30;auxc++){//passo

       for(auxb=0; auxb<12;auxb++){//permanncia
         inverte_saida();
       }
       if(cnt>128){
         cnt = cnt - 2;
       }
       else{
         cnt = cnt + 2;
       }
     }
   // }
 }


void som_sirene5(){
   //sirene  disparos rpidos (usar junto com outra)
 //   for(auxd=0; auxd<50;auxd++){//numero de execues
    cnt=20;//frequencia
     for(auxc=0; auxc<10;auxc++){//passo

       for(auxb=0; auxb<12;auxb++){//permanncia
         inverte_saida();
       }
       if(cnt>128){
         cnt = cnt - 5;
       }
       else{
         cnt = cnt + 5;
       }
     }
  //  }
}

void som_sirene6(){

   //sirene (iaaauuuuu!  iiiaaauuu!)
  //  for(auxd=0; auxd<10;auxd++){//numero de execues
    cnt=20;//frequencia
     for(auxc=0; auxc<10;auxc++){//passo

       for(auxb=0; auxb<80;auxb++){//permanncia
         inverte_saida();
       }
       if(cnt>128){
         cnt = cnt - 5;
       }
       else{
         cnt = cnt + 5;
       }
     }
  //  }
}

void som_sirene7(){
//sirene tipo policia
  //  for(auxd=0; auxd<30;auxd++){//numero de execues
    cnt=39;//frequencia
     for(auxc=0; auxc<12;auxc++){//passo

       for(auxb=0; auxb<6;auxb++){//permanncia
         inverte_saida();
       }
       cnt = cnt - 5;
     }
  //  }
}

void som_sirene8(){
 //sirene alarme rpido 1
  //  for(auxd=0; auxd<10;auxd++){//numero de execues
    cnt=40;//frequencia
     for(auxc=0; auxc<50;auxc++){//passo

       for(auxb=0; auxb<5;auxb++){//permanncia
         inverte_saida();
       }
       if(cnt>128){
         cnt = cnt - 2;
       }
       else{
         cnt = cnt + 6;
       }
     }
   // }
}

void som_sirene9(){

  //som de arma espacial 1 (tchooo') lento
  //  for(auxd=0; auxd<10;auxd++){//numero de execues
    cnt=40;//frequencia
     for(auxc=0; auxc<50;auxc++){//passo

       for(auxb=0; auxb<9;auxb++){//permanncia
         inverte_saida();
       }
       if(cnt>128){
         cnt = cnt - 2;
       }
       else{
         cnt = cnt + 6;
       }
     }
   // }
}

void som_sirene10(){
//gun space
  //  for(auxd=0; auxd<10;auxd++){//numero de execues
    cnt=39;//frequencia
     for(auxc=0; auxc<18;auxc++){//passo

       for(auxb=0; auxb<9;auxb++){//permanncia
         inverte_saida();
       }
       cnt = cnt - 8;
     }
  //  }
}

void som_sirene11(){
 //space gun 5 rpida (metralhando)
  //  for(auxd=0; auxd<20;auxd++){//numero de execues
    cnt=10;//frequencia
     for(auxc=0; auxc<10;auxc++){//passo

       for(auxb=0; auxb<30;auxb++){//permanncia
         inverte_saida();
       }
       if(cnt>128){
         cnt = cnt - 7;
       }
       else{
         cnt = cnt + 3;
       }
     }
   // }
}
void som_sirene12(){

       //space gun 4 rpida (metralhando)
  //  for(auxd=0; auxd<20;auxd++){//numero de execues
    cnt=20;//frequencia
     for(auxc=0; auxc<30;auxc++){//passo

       for(auxb=0; auxb<6;auxb++){//permanncia
         inverte_saida();
       }
       if(cnt>128){
         cnt = cnt - 2;
       }
       else{
         cnt = cnt + 4;
       }
     }
   // }
}
void som_sirene13(){
//gun space2
   // for(auxd=0; auxd<10;auxd++){//numero de execues
    cnt=44;//frequencia
     for(auxc=0; auxc<18;auxc++){//passo

       for(auxb=0; auxb<9;auxb++){//permanncia
         inverte_saida();
       }
       cnt = cnt - 8;
     }
   // }
}

void som_sirene14(){
  //space gun 3 (tchuuu! tchuuu!)
  //  for(auxd=0; auxd<10;auxd++){//numero de execues
    cnt=20;//frequencia
     for(auxc=0; auxc<30;auxc++){//passo

       for(auxb=0; auxb<12;auxb++){//permanncia
         inverte_saida();
       }
       if(cnt>128){
         cnt = cnt - 2;
       }
       else{
         cnt = cnt + 4;
       }
     }
  //  }
}

void som_sirene15(){
  //extranha (doleto bum doleto bum)
 //   for(auxd=0; auxd<10;auxd++){//numero de execues
    cnt=37;//frequencia
     for(auxc=0; auxc<10;auxc++){//passo

       for(auxb=0; auxb<40;auxb++){//permanncia
         inverte_saida();
       }
       cnt = cnt - 20;
     }
  //  }
}

void som_sirene16(){
 //poim poim
  //  for(auxd=0; auxd<10;auxd++){//numero de execues
    cnt=100;//frequencia
     for(auxc=0; auxc<10;auxc++){//passo

       for(auxb=0; auxb<40;auxb++){//permanncia
         inverte_saida();
       }
       cnt = cnt - 40;
     }
   // }
}
void som_sirene17(){

  //bp
 //   for(auxd=0; auxd<10;auxd++){//numero de execues
    cnt=20;//frequencia
     for(auxc=0; auxc<10;auxc++){//passo

       for(auxb=0; auxb<80;auxb++){//permanncia
         inverte_saida();
       }
       cnt = cnt - 50;
     }
   // }
}

void som_sirene18(){
 //sirene alarme rpido 1
   // for(auxd=0; auxd<10;auxd++){//numero de execues
    cnt=40;//frequencia
     for(auxc=0; auxc<50;auxc++){//passo

       for(auxb=0; auxb<15;auxb++){//permanncia
         inverte_saida();
       }
       if(cnt>128){
         cnt = cnt ^ 0b10000000;
       }
       else{
         cnt = cnt + 1;
       }
     }
  //  }
}

void som_sirene19(){
  // for(auxd=0; auxd<10;auxd++){//numero de execues
     for(auxc=0; auxc<50;auxc++){//passo
       cnt=20;
       for(auxb=0; auxb<15;auxb++){//permanncia
         inverte_saida();
       }
       cnt=15;
       for(auxb=0; auxb<15;auxb++){//permanncia
         inverte_saida();
       }
     }
  //  }
}

void som_sirene20(){//2 tons

      cnt=72;
      for(auxc=0; auxc<40;auxc++){//passo
        for(auxb=0; auxb<25;auxb++){//permanncia
           inverte_saida();
        }
      }
      cnt=81;
      for(auxc=0; auxc<40;auxc++){//passo
        for(auxb=0; auxb<25;auxb++){//permanncia
           inverte_saida();
        }
      }

}

void som_sirene21(){//campainha telefone 2
  cnt=64;

     for(auxc=0; auxc<3;auxc++){//passo
       cnt=91;
       for(auxb=0; auxb<30;auxb++){//permanncia
         inverte_saida();
       }
       cnt=102;
       for(auxb=0; auxb<30;auxb++){//permanncia
         inverte_saida();
       }


    }

     for(auxc=0; auxc<3;auxc++){//passo
       cnt=81;
       for(auxb=0; auxb<30;auxb++){//permanncia
         inverte_saida();
       }
       cnt=91;
       for(auxb=0; auxb<30;auxb++){//permanncia
         inverte_saida();
       }
     }


}

void som_sirene22(){
 // for(auxe=0;auxe<3;auxe++){//numero de execues
    cnt=100;//frequencia

    for(auxd=0; auxd<4;auxd++){//passo 2

     for(auxc=0; auxc<10;auxc++){//passo

       for(auxb=0; auxb<40;auxb++){//permanncia
         inverte_saida();
       }
       cnt = cnt - 40;
     }
    }
    cnt=112;
 // }
}

void som_sirene23(){
// for(auxe=0; auxe<5;auxe++){//numero de execues
    cnt=70;//frequencia
  //poim poim
    for(auxd=0; auxd<5;auxd++){//numero de execues

     for(auxc=0; auxc<15;auxc++){//passo

       for(auxb=0; auxb<40;auxb++){//permanncia
         inverte_saida();
       }
       cnt = cnt - 50;
     }
    }
    cnt=79;
 //}
}

void som_sirene24(){
// for(auxd=0; auxd<3;auxd++){//numero de execues
    cnt=10;//frequencia
     for(auxc=0; auxc<15;auxc++){//passo

       for(auxb=0; auxb<70;auxb++){//permanncia
         inverte_saida();
       }
       cnt = cnt - 12;
     }
  //  }
}
/*******************************************************************************
                          Rotina Main
*******************************************************************************/

void main() {
     GPIO_Digital_Output(&GPIOA_BASE, _GPIO_PINMASK_10);  // pino A10 como sada de som

     //Configura os pinos dos jumpers
     GPIO_Config(&GPIOB_BASE,
            _GPIO_PINMASK_11 | _GPIO_PINMASK_12 | _GPIO_PINMASK_13 | _GPIO_PINMASK_14 |
            _GPIO_PINMASK_15 , _GPIO_CFG_MODE_INPUT | _GPIO_CFG_PULL_UP);
      
     GPIOA_ODR.B10 = 0;//sada de som desligada
     
     //configura timer2 como base de tempo
     RCC_APB1ENR.TIM2EN = 1;       // Enable clock gating for timer module 2
     TIM2_CR1.CEN = 0;             // Disable timer
     TIM2_PSC = 1999;              // Set timer prescaler. 8mhz/(1999+1)=4002 (para 1 segundo)
     TIM2_ARR = 4002;
     NVIC_IntEnable(IVT_INT_TIM2); // Enable timer interrupt
     TIM2_DIER.UIE = 1;            // Update interrupt enable
     TIM2_CR1.CEN = 1;             // Enable timer

/*******************************************************************************
                          Loop
*******************************************************************************/
            
     for(;;){
     
       vez=0;
       if(j3==0)vez=vez + 1;
       if(j5==0)vez=vez + 2;
       if(j6==0)vez=vez + 4;
       if(j7==0)vez=vez + 8;

       switch (vez){

       case 1:
         som_sirene2();
         break;

       case 2:
         som_sirene3();
         break;

       case 3:
         som_sirene4();
         break;

       case 4:
         som_sirene5();
         break;

       case 5:
         som_sirene6();
         break;

       case 6:
         som_sirene7();
         break;

       case 7:
         som_sirene1();
         break;

       case 8:
        som_sirene20();
         break;

       case 9:
         som_sirene10();
         break;

       case 10:
         som_sirene11();
         break;

       case 11:
         som_sirene12();
         break;

       case 12:
         som_sirene13();
         break;

       case 13:
         som_sirene14();
         break;

       case 14:
         som_sirene15();
         break;

       case 15:
         som_sirene18();
         break;


      }//switch
      
      

      //Verifica se jumper para desligamento temporizado est ligado
      if(j4==0){
        if(timerOut>VALOR_DESLIGAMENTO){
           timerOut=0; //zera contador
           for(;;);   // para de tocar (sai do lao somente no reset)
         }
      }

     }
}